{% extends "base_device.yaml.jinja2" %}

{% block device_setup %}
device_type: stm32mp157c-dk2

job_name: {{ settings.CI_JOB_NAME }}

timeouts:
  job:
    minutes: 60
  action:
    minutes: 20
  connection:
    minutes: 20

priority: medium

visibility: public

context:
  test_character_delay: 30

actions:

- deploy:
    to: downloads
    images:
      firmware:
        url: {{ firmware_url }}
        {%- set firmware_path, firmware_extension = splitext(firmware_url) %}
        compression: {{ firmware_extension[1:] }}
      os:
        url: {{ os_url }}
        {%- set os_path, os_extension = splitext(os_url) %}
        compression: {{ os_extension[1:] }}
      script:
        url: https://git.linaro.org/ci/job/configs.git/plain/ledge/ts/scripts/ts-merge-images.sh
    postprocess:
      docker:
        image: debian
        steps:
          {%- set os_filename = basename(os_path) %}
          {%- set firmware_filename = basename(firmware_path) %}
          - 'apt-get update'
          - 'apt-get install -qy fdisk gdisk'
          - 'fdisk -l {{ firmware_filename }}'
          - 'fdisk -l {{ os_filename }}'
          - 'bash ts-merge-images.sh {{ firmware_filename }} {{ os_filename }}'
          - 'fdisk -l {{ firmware_filename }}'
          - 'mv {{ firmware_filename }} sdcard.bin'

- deploy:
    timeout:
      minutes: 60
    to: flasher
    images:
      tarball:
        url: http://git-us.linaro.org/ci/job/configs.git/plain/ledge/ts/scripts/stm32.tar.gz
      layout:
        url: {{ settings.BLUEPRINTSCI_URL }}/-/raw/main/support_files/stm32mp157c-sdcard-single.tsv
      sdcard:
        url: downloads://sdcard.bin
        partition: 4
        format: ext4
        overlays:
          lava: true

    os: oe

- boot:
    timeout:
      minutes: 15
    method: u-boot
    uboot_final_message: "EFI stub: UEFI Secure Boot is enabled."
    final_message: "EFI stub: UEFI Secure Boot is enabled."
    auto_login:
      login_prompt: 'ledge-qemuarm login:'
      username: ''
    prompt:
      - "=>"
    commands:
      - ls mmc 0:4 /
      - ls mmc 0:5 /
      - efidebug boot add -b 1 BootLedge mmc 0:4 efi/boot/bootarm.efi -i
          mmc 0:4 ledge-initramfs.rootfs.cpio.gz -s 'console=ttySTM0,115200 root=UUID=6091b3a4-ce08-3020-93a6-f755a22ef03b rootwait panic=10'
      - efidebug boot order 1
      - echo "Starting kernel"; bootefi bootmgr

- boot:
    timeout:
      minutes: 15
    method: minimal
    reset: false
    prompts:
      - 'ledge-qemuarm:'
    auto_login:
      login_prompt: 'login:'
      username: "ledge"
      password_prompt: 'Password:'
      password: "ledge"

- test:
   timeout:
     minutes: 5
     skip: false
   interactive:
   - name: sudo
     prompts:
       - ewaol@(.*):[/~]\$
       - root@(.*):[/~]#
       - "ledge-qemuarm:"
     echo: discard
     script:
     - name: sudo
       command: "sudo -i"

{% endblock %}
